enemy_stance = {}

enemy_stance.on_init = function()
  global.forces_connected_players = {}
  print("OnInit")
end

enemy_stance.on_player_joined_game = function(event)
  local player = game.players[event.player_index]
  if player and player.valid and player.force.name ~= "player" and global.forces_connected_players[player.force.name] == nil then
    print("First player in force " .. player.force.name)
    global.forces_connected_players[player.force.name] = 600
  end
end

enemy_stance.on_player_left_game = function(event)
  local force = game.players[event.player_index].force
  local force_has_connected_player = false
  for _,player in pairs(force.players) do
    if player.index ~= event.player_index and player.connected then force_has_connected_player = true end
  end
  if not force_has_connected_player then
    team_changed_diplomacy(game.forces["enemy"], force, "neutral")
    print("Force " .. force.name .. " has no connected players.")
    if global.forces_connected_players[force.name] ~= nil then
      global.forces_connected_players[force.name] = nil
    end
  end
end

enemy_stance.on_tick = function(event)
  if global.forces_connected_players == nil then return end
  for force_name,time in pairs(global.forces_connected_players) do
    if time == 0 then
      print("Set alien enemy for force " .. force_name)
      team_changed_diplomacy(game.forces["enemy"], game.forces[force_name], "enemy")
      global.forces_connected_players[force_name] = nil
    else
      global.forces_connected_players[force_name] = global.forces_connected_players[force_name] - 1
    end
  end
end

return enemy_stance

